;IdleArts Runt an autocomplete run box v1.32 and IdleArts logo
;Copyright (C) 2010 Andrew Ferguson 
;www.idlearts.com 

;This program is free software: you can redistribute it And/Or modify
;it under the terms of the GNU General Public License As published by
;the Free Software Foundation, either version 3 of the License, Or
;any later version.

;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY Or FITNESS For A PARTICULAR PURPOSE.  See the
;GNU General Public License For more details.

;You should have received a copy of the GNU General Public License
;along With this program.  If Not, see <http://www.gnu.org/licenses/>.

;PureBasic 4.51
;Note
;saves its Data file in users Application data folder under runt
;once a scan is completed it will starts up invisible in the systray
;Use Add to StartUp menu to create shell lnk to Startup folder

;Use 
;Scan a drive or all the computer 
;left click systray icon to show window
;right click systray icon to end program 
;Type in part of a application name And use the Up Down Left Right arrow keys To Select 
;Press Return or Double click an Item in List or Click the Image Button to run   
;
;Quick launch groups 
;right click in right pane to create a new group 
;find an application click on it in the list 
;drag item to the launch group
;to launch a groups press the associasted number key 
;Change log 1.32 
; Added Desktop Icon Restore 
;Change log 1.31b
; Added move delete in group launch (hacked)
;Change log 1.31a
; Changed file format
; Added quick launch groups
;Change log 1.3 
; Added Shell link to startup folder 
; Changed location of runt.lbn to users application data folder \ runt  
; Added popup menu for quit

Global gVString.s = "1.32"

;{

EnableExplicit

Structure edge
   edge.i[256] 
EndStructure

Structure TrieNode;
   Value.i;
   Count.i;
   Vertex.edge
EndStructure;

Structure Trie
  *vt.i
  *root.TrieNode;
EndStructure;

Declare FreeNodes(*node.TrieNode)
Declare NewTrie(*obj.Trie)
Declare FreeTrie(*this.Trie)
Declare AddTrie(*this.Trie,key.s,value.i=1)
Declare lookupTrie(*this.Trie,key.s)
Declare iEnumTrie(*this.Trie,*node.TrieNode,key.s,*fn)
Declare EnumTrie(*this.Trie,key.s,*fn.i)

Interface clsTrie
  Free()
  Add(key.s,item.i=1)
  LookUp(key.s)
  Enum(key.s,*fn.i)
EndInterface   


Procedure FreeNodes(*node.TrieNode)
  ;Free all Trie Nodes
  Protected a.i
   If Not *node
      ProcedureReturn;
   EndIf
   
   For a=0 To 255
      FreeNodes(*node\Vertex\edge[a]);
   Next
   
   If *node
     FreeMemory(*node)
   EndIf 
   
EndProcedure

Procedure NewTrie(*obj.Trie)
  *obj = AllocateMemory(SizeOf(Trie))
  If *obj
   *obj\vt=?vt_Trie
  EndIf
  *obj\root = AllocateMemory(SizeOf(TrieNode))
 
  ProcedureReturn *obj
EndProcedure

Procedure FreeTrie(*this.Trie)
  ;free the Trie
  FreeNodes(*this\root)
  FreeMemory(*this)
 
EndProcedure

Procedure AddTrie(*this.Trie,key.s,value.i=1)
  ;Add item to the Trie, value is optional
  Protected *tnode.TrieNode,*node.TrieNode,len.i,tkey.i,lkey.i,pos.i
  len = Len(key)
   lkey.i
   
   If Not len
     ProcedureReturn;
   EndIf

   *node = *this\root;
   
   While pos < Len+1
    
     tkey = PeekB(@key+pos) & $FF
    
     If Not *node          
      *node = AllocateMemory(SizeOf(TrieNode))
        *tnode\Vertex\edge[lkey] = *node
      EndIf

      *node\count + 1
        
     If pos = len 
       *node\value = value
       ;add value node   
     EndIf
      
      *tnode = *node
      *node = *node\Vertex\edge[tkey]
      lkey = tkey
      pos+1
      
   Wend
   
EndProcedure

Procedure lookupTrie(*this.Trie,key.s)
  ;Find the value of the key returns the value or 0
  Protected *node.TrieNode,*bkey.byte,result.i   
    
  *node = *this\root
  *bkey = @key 
  *node = *node\Vertex\edge[*bkey\b & $FF]
 
  While *bkey\b <> 0 
   
      If Not *node
         ProcedureReturn 0
      EndIf
      *bkey+1
      result = *node\value
      *node = *node\Vertex\edge[*bkey\b & $FF]
      
   Wend
   
   ProcedureReturn result
   
EndProcedure

Procedure iEnumTrie(*this.Trie,*node.TrieNode,key.s,*fn)
  ;internal Enum trie 
  Protected a.i,tkey.s
 
  If Not *node
      ProcedureReturn;
   EndIf
   
   ;build the key   
   For a=0 To 255
     If *node\Vertex\edge[a]
       tkey = key + Chr(a)
       iEnumTrie(*this,*node\Vertex\edge[a],tkey,*fn);
     Else
       tkey = key
     EndIf 
   Next
   
   ;lookup the key
   If lookupTrie(*this,tkey)
     CallFunctionFast(*fn,@tkey)
     key=tkey
     ProcedureReturn *node
   EndIf   
      
EndProcedure

Procedure EnumTrie(*this.Trie,key.s,*fn.i)
  ;enumerate all the entries below given root key
  Protected *node.TrieNode,*tnode.TrieNode,tkey.i,len.i,pos.i
 
  *node = *this\root;
  tkey = PeekB(@key) & $FF;
  len = Len(key)
  *node = *node\Vertex\edge[tkey]
 
  ;find the root   
  While *node
   
    If *node
       *tnode =*node
     EndIf
    
     pos+1
     tkey = PeekB(@key+pos) & $FF
     *node = *node\Vertex\edge[tkey]
        
   Wend
   ;enum the root
   While *tnode
    
     *tnode = iEnumTrie(*this,*tnode,key,*fn)
     tkey = PeekB(@key+pos) & $FF
    
     If *tnode
      *tnode = *tnode\Vertex\edge[tkey]
     EndIf   
    
   Wend
   
EndProcedure

DataSection: vt_Trie:
  Data.i @FreeTrie()
  Data.i @AddTrie()
  Data.i @lookupTrie()
  Data.i @EnumTrie()
EndDataSection   

;}

;
;chained array list structure-------------- 
;{
;handles multiple entries to cycle through with left right arrows 
Structure vec
   file.s
   name.s
   *next.vec;
EndStructure

Structure Node
  *head.i
  *v.vec
  count.i
 EndStructure 
 
    
Macro AddElementV(vc)
  
 If Not vc\head 
   vc\v = AllocateMemory(SizeOf(vec))
   vc\head = vc\v 
   vc\count+1
 Else   
   vc\v\next = AllocateMemory(SizeOf(vec)) 
   vc\v = vc\v\next
   vc\count+1
 EndIf
 
EndMacro 

Procedure DelElementV(*vc.node,Pos)
  Protected *t.vec,*dv.vec,a,berr 
  If *vc\v 
    *vc\v = *vc\head 
    If pos = 1 
     *t = *vc\v\next 
      ClearStructure(*vc\v,vec)
      FreeMemory(*vc\v)
      *vc\head = *t
      *vc\count-1
    Else   
      For a = 1 To pos-1 
         If *vc\v 
          *dv = *vc\v
          *vc\v = *vc\v\next
         Else 
           berr=1 
         EndIf   
      Next
      If Not berr 
        *t = *vc\v\next
        Debug *vc\v\name
        ClearStructure(*vc\v,vec)
        FreeMemory(*vc\v)
        *dv\next = *t
        *vc\count-1
      EndIf
    EndIf 
 EndIf    
EndProcedure   

Procedure InsertElementV(*vc.node,pos)
  Protected *t.vec,*prev.vec,*nv.vec,a 
  *nv = AllocateMemory(SizeOf(vec))
  *t = *vc\head 
  If pos = 1 
    *vc\v = *nv 
    *vc\head = *nv   
    *nv\next = *t 
  Else 
    For a = 1 To pos-1 
      *prev = *t
      *t = *t\next
    Next 
    *prev\next = *nv 
    *nv\next = *t
    *vc\v = *nv
  EndIf   
    
EndProcedure   

Procedure SwapElementsV(*vc.node,p1,p2) 
  Protected *p1.vec,*p2.vec,*t.vec,t.vec,a 
  *t=*vc\head
  For a = 1 To p1-1
       *t=*t\next  
  Next
  *p1=*t
  *t=*vc\head
  For a = 1 To p2-1
     *t=*t\next 
  Next
  *p2 =*t
  t.vec 
  t\file = *p1\file
  t\name = *p1\name
  InsertElementV(*vc,p1)
  *vc\v\file = *p2\file
  *vc\v\name = *p2\name
  DelElementV(*vc,p1+1)
  InsertElementv(*vc,p2)
  *vc\v\file = t\file 
  *vc\v\name = t\name
  DelElementV(*vc,p2+1) 
  
EndProcedure   

Macro FreeVec(vc)
  Protected *v.vec,*vv.vec  
  If vc\v
    *v.vec = vc\head
    Repeat  
      *vv.vec = *v\Next
      ClearStructure(*v,vec)
      FreeMemory(*v)
      *v=*vv
    Until *v=0 
    If *vv 
      ClearStructure(*vv,vec)
      FreeMemory(*vv)
    EndIf   
    vc\head = 0
    vc\v = 0
  EndIf 
EndMacro  
   
 ;main file array handles multiple items in single linked list
 Global Dim gApps.Node(100)
 Global gAppCnt
 ;Quick launch list 
 Global Dim gLApps.node(10)
  
Procedure FreeFileList()
  Protected a
  For a = 0 To gAppCnt 
    If gApps(a)\v 
      FreeVec(gApps(a))
    EndIf 
  Next   
  
EndProcedure 

Procedure FreeLaunchList()
  Protected a 
  For a = 0 To 8 
    If gLApps(a)\v 
      FreeVec(gLApps(a))
    EndIf 
  Next
EndProcedure   
;}

Global result.s 
Global mt.clsTrie = NewTrie(@mt)
Global gScanDone,gappSize,gpt,gimg,sdfile.s,sdqfile.s,sdDeskfile.s,gmpop 
Global gWinScan,gKillScan,gScanDone,gscanpos,gloaded,gTotalDriveSize.q,gScanSum.q,gmwind,gWindAbout
Structure fDat 
  fsz.i
  asz.i
  file.s 
  app.s
EndStructure   

Structure fhead
  version.i
  launchdat.i
EndStructure  

Structure scaninf
  mode.i 
  dir.s 
EndStructure 

Enumeration
  #LV_APPS
  #S_APP
  #BG1 
  #T_APP
  #T_AppCount
  #M_ReScan
  #PBar
  #TDrive
  #TFile
  #TCount 
  #menu
  #quit
  #down
  #up
  #left
  #right
  #return 
  #M_ShortCut
  #escape
  #M_About
  #txt_about
  #Hyp_link
  #wind_about
  #TR_LAPPS
  #dell
  #M_SaveIcon
  #M_RestoreIcon
EndEnumeration


Procedure CreateShellLink(PATH$, LINK$, Argument$, DESCRIPTION$, WorkingDirectory$, ShowCommand.l, HotKey.l, IconFile$, IconIndexInFile.l)
  Protected psl.IShellLinkA,ppf.IPersistFile,*mem,len,hres,res.s
  
  CoInitialize_(0)
  If CoCreateInstance_(?CLSID_ShellLink,0,1,?IID_IShellLink,@psl.IShellLinkA) = 0
     
   Set_ShellLink_preferences:
   psl\SetPath(PATH$)
   psl\SetArguments(Argument$)
   psl\SetWorkingDirectory(WorkingDirectory$)
   psl\SetDescription(DESCRIPTION$)
   psl\SetShowCmd(ShowCommand)
   psl\SetHotkey(HotKey)
   psl\SetIconLocation(IconFile$, IconIndexInFile)
        
   ShellLink_SAVE:
      If psl\QueryInterface(?IID_IPersistFile,@ppf.IPersistFile) = 0
        *mem = AllocateMemory(1000) 
        len = MultiByteToWideChar_(#CP_ACP, 0, LINK$, -1, *mem, 1000)
        res.s = PeekS(*mem,len,#PB_Unicode)
        hres = ppf\Save(res,#True)
        FreeMemory(*mem)
        ppf\Release()
      EndIf
      psl\Release()
   EndIf
   CoUninitialize_()
   ProcedureReturn hres ! 1
   
   DataSection
     CLSID_ShellLink:
       ; 00021401-0000-0000-C000-000000000046
       Data.l $00021401
       Data.w $0000,$0000
       Data.b $C0,$00,$00,$00,$00,$00,$00,$46
     IID_IShellLink:
       ; DEFINE_SHLGUID(IID_IShellLinkA,0x000214EEL, 0, 0);
       ; C000-000000000046
       Data.l $000214EE
       Data.w $0000,$0000
       Data.b $C0,$00,$00,$00,$00,$00,$00,$46
     IID_IPersistFile:
       ; 0000010b-0000-0000-C000-000000000046
       Data.l $0000010b
       Data.w $0000,$0000
       Data.b $C0,$00,$00,$00,$00,$00,$00,$46
   EndDataSection

EndProcedure


Procedure.s GetSpecialFolderLocation(Value.l)
  Protected Folder_ID,SpecialFolderLocation.s
 
  If SHGetSpecialFolderLocation_(0, Value, @Folder_ID) = 0
    SpecialFolderLocation = Space(#MAX_PATH*2)
    SHGetPathFromIDList_(Folder_ID, @SpecialFolderLocation)
    If SpecialFolderLocation
      If Right(SpecialFolderLocation, 1) <> "\"
        SpecialFolderLocation + "\"
      EndIf
    EndIf
    CoTaskMemFree_(Folder_ID)
  EndIf
   ProcedureReturn SpecialFolderLocation.s
EndProcedure

#CSIDL_STARTUP = $7
#CSIDL_APPDATA = $1A
sdfile = GetSpecialFolderLocation(#CSIDL_APPDATA) + "runt\runt.lbn"
sdqfile = GetSpecialFolderLocation(#CSIDL_APPDATA) + "runt\runtq.lbn"
sdDeskfile = GetSpecialFolderLocation(#CSIDL_APPDATA) + "runt\desk.lbn"

XIncludeFile "eula.pb"
XIncludeFile "desktop.pbi"

Procedure AddtoStartMenu()
  Protected tpath.s = GetSpecialFolderLocation(#CSIDL_STARTUP) + "runt.lnk"
  CreateShellLink(ProgramFilename(),tpath,"","Runt","",0,0,ProgramFilename(),0)
EndProcedure   

Procedure addapp(filePath.s,name.s,fn)
    Protected id,dat.fdat,*v.vec,bfound,sz,*buf  
    
    If gAppCnt >= gAppSize 
      gAppSize + 100 
      ReDim gapps.node(gAppSize) 
    EndIf   
    
    *buf = AllocateMemory(1024)
    
    id = mt\LookUp(name) 
    If Not id 
      gAppCnt+1
      mt\Add(name,gAppCnt)
      AddElementV(gapps(gAppCnt))
      gApps(gAppCnt)\v\file = filepath  
      If IsFile(fn)
        dat\app = name
        dat\file = filePath 
        dat\fsz = Len(filepath)
        dat\asz = Len(name) 
        FileSeek(fn,Lof(fn))
        WriteData(fn,@dat\fsz,SizeOf(integer))
        WriteData(fn,@dat\asz,SizeOf(integer))
        PokeS(*buf,dat\file,dat\fsz)
        WriteData(fn,*buf,dat\fsz)
        PokeS(*buf,dat\app,dat\asz)
        WriteData(fn,*buf,dat\asz)
        
      EndIf 
      
    Else 
      *v.vec = gapps(id)\head
      While *v  
        If *v\file = filepath 
          bfound = 1  
          Break  
        EndIf
        *v = *v\next 
      Wend 
      If Not bfound 
        AddElementV(gapps(id))
        gApps(id)\v\file = filepath   
        If IsFile(fn)
          dat.fDat
          dat\app = name
          dat\file = filePath 
          dat\fsz = Len(filepath)
          dat\asz = Len(name) 
          FileSeek(fn,Lof(fn))
          WriteData(fn,@dat\fsz,SizeOf(integer))
          WriteData(fn,@dat\asz,SizeOf(integer))
          PokeS(*buf,dat\file,dat\fsz)
          WriteData(fn,*buf,dat\fsz)
          PokeS(*buf,dat\app,dat\asz)
          WriteData(fn,*buf,dat\asz)
                   
        EndIf   
      EndIf   
    EndIf    
    FreeMemory(*buf)
    
EndProcedure   

Procedure.s dirlist(dir.s,bRec,ofn):
  Static strFiles.s,ct1 
  Protected td.s,img,ts.s,sumf.f,tot.f,mdir,scanpos,FN.s,exe.s,FFN.s
  mDir=ExamineDirectory(#PB_Any,dir,"*.*")  
  
  If mDir  
    While NextDirectoryEntry(mDir)
      gScanSum + DirectoryEntrySize(mDir)
      If gTotalDriveSize <> 0 And gScanSum <> 0 And gWinScan  
        sumf = gScanSum
        tot = gTotalDriveSize
        Scanpos = Int((sumf / tot) * 100.0) 
        SetGadgetState(#pbar,Scanpos)
      EndIf  
      If DirectoryEntryType(mDir)=#PB_DirectoryEntry_File
        FN.s=DirectoryEntryName(mDir):
        exe.s = GetExtensionPart(FN)
        If exe = "exe"   
           FFN.s= dir+"\"+FN
           If IsWindow(gWinScan)
             SetGadgetText(#Tfile,FFN)
           EndIf  
           ts.s = LCase(Left(FN,Len(FN)-4))
           img = ExtractIcon_(0,ffn,0)
           If img 
             If FindString(ts,"setup",1) = 0 And FindString(ts,"install",1) = 0 And FindString(ts,"_",1) = 0 And FindString(ts,"-",1) = 0 
               addApp(FFN,ts,ofn)
               ct1+1
             EndIf   
           EndIf   
         EndIf
       Else
         td=DirectoryEntryName(mDir)
         If td <> "." And td <> ".."
           If bRec=0
             dirlist(Dir+"\"+td,bRec,ofn)
           EndIf
         EndIf
      EndIf
    Wend
    FinishDirectory(mDir)
  EndIf
EndProcedure:

Procedure AddToDB(*scan.scaninf)
  Protected d,drive.s,filn,fn.i,ts.s,dir.s,indat.fdat 
  Protected fb.q,tb.q,tfb.q,titlecount.i,ret ,*buf 
    
  dir=*scan\dir
    
  SetErrorMode_(#SEM_FAILCRITICALERRORS)
    
  If *scan\mode=1 Or *scan\mode=2
    
    fn = OpenFile(-1,sdfile)
    If fn 
    If dir = "\"
          
      For d = 'A' To 'Z' 
        gScanSum=0
        dir = Chr(d) + ":\"
        SetGadgetText(#TDrive,dir)
        GetDiskFreeSpaceEx_(dir,@fb,@TB,@TFB)
        gTotalDriveSize = (TB - TFB) 
        dirlist(dir,0,fn)
      Next  
     
    Else 
             
      drive  = Left(dir,3)
      gScanSum=0
      GetDiskFreeSpaceEx_(drive,@fb,@TB,@TFB)
      gTotalDriveSize = (TB - TFB) 
      SetGadgetText(#TDrive,drive)
      dirlist(dir,0,fn)
    EndIf   
    CloseFile(fn)
    EndIf 
  ElseIf *scan\mode=0 
    fn=ReadFile(#PB_Any,sdfile)
    If fn
       *buf = AllocateMemory(1024)
      While Not Eof(fn)
        ReadData(fn,@indat,2*SizeOf(integer))
        ReadData(fn,*buf,indat\fsz)
        indat\file = PeekS(*buf,indat\fsz)
        ReadData(fn,*buf,indat\asz)
        indat\app = PeekS(*buf,indat\asz)
        addapp(indat\file,indat\app,0)
      Wend
      FreeMemory(*buf)
      CloseFile(fn)
      ret = 1  
    EndIf 
 EndIf
  gScanDone = 1
  
  SetErrorMode_(0)
  
  ProcedureReturn ret 
  
EndProcedure  

Procedure Open_ScanGui(mode)
 Protected tlen,fn,title.s,evs.i,dir.s,scan.scaninf,result,bScanAll 
 title = "Runt Scanner"  
 StickyWindow(gmwind,0)
 
 fn = OpenFile(-1,sdfile)
 If Not fn
   CreateDirectory(GetPathPart(sdfile)) 
   fn = OpenFile(-1,sdfile)
 EndIf 
 
 If fn 
        
 tlen = Lof(fn) 
 CloseFile(fn)
 
   If tlen = 0 Or mode   
     
     If tlen = 0 
       result = MessageRequester("Runt Scanner - search apps","Would like to scan your entire system?",#PB_MessageRequester_YesNo)
       If result = #PB_MessageRequester_Yes
         bScanAll=1
         dir = "\"
       EndIf
       mode=1
     EndIf   
       
     If Not bScanAll 
        dir.s = PathRequester("Please choose a directory To scan","")
        dir = Left(dir,Len(dir)-1)
     EndIf     
     
     scan\mode = mode
     scan\dir = dir 
     
     If dir <> ""
     
     gWinScan = OpenWindow(-1, 354, 253, 492, 126, Title, #PB_Window_ScreenCentered | #PB_Window_SystemMenu | #PB_Window_SizeGadget | #PB_Window_TitleBar )
     StickyWindow(gWinScan,1)
      If gWinScan
         ProgressBarGadget(#PBar, 5, 85, 480, 35, 0, 100, #PB_ProgressBar_Smooth)
         TextGadget(#TDrive, 10, 10, 90, 30, "")
         TextGadget(#TFile, 10, 50, 475, 30, "")
         TextGadget(#TCount, 100, 10, 200,30,"")
      EndIf
      
      If dir <> ""
           
        
        gScanDone=0
        CreateThread(@AddToDB(),@scan)
   
        Repeat 
   
           evs=WindowEvent()
           Delay(0)
   
         Until gScanDone Or evs=#WM_CLOSE  
      Else 
        If IsWindow(gWinScan)
          CloseWindow(gWinScan)
        EndIf   
         gWinScan=0
      EndIf    
      If gScanDone
        If IsWindow(gWinScan)
          CloseWindow(gWinScan)
        EndIf   
        gWinScan=0
      EndIf
      
      EndIf 
      
   Else 
     scan\mode = 0
     scan\dir = ""
     
     AddToDB(@scan)
  
        
  EndIf  
  StickyWindow(gmwind,1)
EndIf 
  
EndProcedure

Procedure UpdateList(*item)
  Protected item.s
  If *item  
     item.s = PeekS(*item)
     AddGadgetItem(#LV_APPS,-1,item) 
     SetGadgetState(#LV_APPS,0)  
   EndIf 
 EndProcedure   
 
Procedure SetInfo(item.i,count)
  Protected spath.s,img   
  If Item 
    Debug gapps(item)\v\file
    spath.s = gapps(item)\v\file
    img = ExtractIcon_(0,spath,0)
    If img 
       SetGadgetAttribute(#BG1,#PB_Button_Image,img)
    Else 
       SetGadgetAttribute(#BG1,#PB_Button_Image,gimg)
    EndIf 
    SetGadgetText(#T_APP,spath)
    SetGadgetText(#T_AppCount,Str(count))
  EndIf   
EndProcedure   

Procedure about(hwnd)
  Protected strabout.s 
  If Not gWindAbout
  strabout = "IdleArts Runt v" + gVString + " Copyright (C) 2010 Andrew Ferguson" + #CRLF$ + #CRLF$  
  strabout + "This program is distributed in the hope that it will be useful, " 
  strabout + "but WITHOUT ANY WARRANTY; without even the implied warranty of "
  strabout + "MERCHANTABILITY or FITNESS For A PARTICULAR PURPOSE." 
  gWindAbout = OpenWindow(-1,0,0,347,186,"IdleArts Runt v" + gvString ,#PB_Window_ScreenCentered | #PB_Window_SystemMenu,hwnd) 
  TextGadget(#txt_about,0,0,347,160,strAbout)
  SetGadgetColor(#txt_about,#PB_Gadget_BackColor,$FFFFFF)
  HyperLinkGadget(#Hyp_link,10,160,165,20,"www.idlearts.com",RGB(0,0,255))
  EndIf   
EndProcedure 

Procedure loadquicklaunch()
  Protected fn,*buf,indat.fdat,pt,ct=-1,*v.vec
  fn = ReadFile(-1,sdqfile)
  
  If fn 
    *buf = AllocateMemory(1024)
    While Not Eof(fn) 
      ReadData(fn,@indat,2*SizeOf(integer))
      ReadData(fn,*buf,indat\fsz)
      indat\file = PeekS(*buf,indat\fsz)
      ReadData(fn,*buf,indat\asz)
      indat\app = PeekS(*buf,indat\asz)
      Debug indat\app
      If indat\file = "*"
        pt=0
        ct+1
       Else 
         pt=1 
      EndIf 
      AddGadgetItem(#TR_LAPPS,-1,indat\app,0,pt)
      AddElementV(gLApps(ct))
      *v.vec = gLApps(ct)\v 
      *v\file = indat\file
      *v\name = indat\app 
    Wend  
      
   FreeMemory(*buf)
   CloseFile(fn)
  EndIf 
  
  
  
EndProcedure   

Procedure SaveQuickLaunch()
  Protected fn,a,*v.vec,dat.fDat,*buf 
  fn = CreateFile(-1,sdqfile)
 
  If fn 
    *buf = AllocateMemory(1024)
    For a = 0 To 8  
      *v.vec = gLApps(a)\head 
      dat\app = Str(a+1) 
      dat\file = "*"
      dat\fsz = Len(dat\file)
      dat\asz = Len(dat\app) 
      FileSeek(fn,Lof(fn))
      WriteData(fn,@dat\fsz,SizeOf(integer))
      WriteData(fn,@dat\asz,SizeOf(integer))
      PokeS(*buf,dat\file,dat\fsz)
      WriteData(fn,*buf,dat\fsz)
      PokeS(*buf,dat\app,dat\asz)
      WriteData(fn,*buf,dat\asz)
      While *v 
        If *v\file <> "*" 
          dat\app = *v\name
          dat\file = *v\file 
          dat\fsz = Len(dat\file)
          dat\asz = Len(dat\app) 
          FileSeek(fn,Lof(fn))
          WriteData(fn,@dat\fsz,SizeOf(integer))
          WriteData(fn,@dat\asz,SizeOf(integer))
          PokeS(*buf,dat\file,dat\fsz)
          WriteData(fn,*buf,dat\fsz)
          PokeS(*buf,dat\app,dat\asz)
          WriteData(fn,*buf,dat\asz)
        EndIf   
        *v = *v\next 
     Wend  
   Next 
   FreeMemory(*buf)
    CloseFile(fn)
  EndIf   
EndProcedure   

Global mod.scaninf,pt.point,rc.rect   
Global pos,id.s,count,a,gi=1,dragtxt.s,badd,ttapp.s 
If CreateMutex_(0,1,"Runt")=0 Or GetLastError_()<>0 : End : EndIf

mod\dir = "\"
mod\mode = 0 

gmwind = OpenWindow(-1,0,0,347,186,"IdleArts Runt v" + gvString,#PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible) 
 
StickyWindow(gmwind,1)
StringGadget(#S_APP,2,5,295,20,"")
TextGadget(#T_AppCount,2,30,10,20,"0")
TextGadget(#T_App,17,30,265,30,"")
gimg = ExtractIcon_(0,"explorer.exe",0)
ButtonImageGadget(#BG1,298,5,48,48,gimg)
ListViewGadget(#LV_APPS,2,60,170,105)
TreeGadget(#TR_LAPPS,174,60,170,105 )
EnableGadgetDrop(#TR_LAPPS,#PB_Drop_Text,#PB_Drag_Copy | #PB_Drag_Move)

If CreateMenu(0, WindowID(gmwind))  ; 
  MenuTitle("Scan")
  MenuItem(#M_ReScan, "Scan for Apps")
  MenuItem(#M_ShortCut,"Add to Startup")
  MenuTitle("Desktop")
  MenuItem(#M_SaveIcon,"Save Icon positions")
  MenuItem(#M_RestoreIcon,"Restore Icon Positions")
  MenuTitle("About")
  MenuItem(#M_About,"About")
EndIf 

If CreatePopupMenu(#menu)
  MenuItem(#quit, "Quit") 
EndIf 

AddKeyboardShortcut(gmwind, #PB_Shortcut_Delete,#dell) 
AddKeyboardShortcut(gmwind, #PB_Shortcut_Down,#down)
AddKeyboardShortcut(gmwind, #PB_Shortcut_Up,#up)
AddKeyboardShortcut(gmwind, #PB_Shortcut_Return,#return) 
AddKeyboardShortcut(gmwind, #PB_Shortcut_Left,#left) 
AddKeyboardShortcut(gmwind, #PB_Shortcut_Right,#right) 
AddKeyboardShortcut(gmwind, #PB_Shortcut_Escape,#escape) 

AddKeyboardShortcut(gmwind, #PB_Shortcut_1,101)
AddKeyboardShortcut(gmwind, #PB_Shortcut_2,102)
AddKeyboardShortcut(gmwind, #PB_Shortcut_3,103)
AddKeyboardShortcut(gmwind, #PB_Shortcut_4,104)
AddKeyboardShortcut(gmwind, #PB_Shortcut_5,105)
AddKeyboardShortcut(gmwind, #PB_Shortcut_6,106)
AddKeyboardShortcut(gmwind, #PB_Shortcut_7,107)
AddKeyboardShortcut(gmwind, #PB_Shortcut_8,108)
AddKeyboardShortcut(gmwind, #PB_Shortcut_9,109)
AddKeyboardShortcut(gmwind, #PB_Shortcut_0,100)

Global aico,*tv.vec,lres,EV,EVG,EVT,EVW,MEV,tapp.s,res,*v.vec,ct,pos,gclose,tmev,gsource,dragtxt.s,tf.s,ct1 

SetActiveGadget(#S_APP)
aico = CatchImage(-1,?ico)
AddSysTrayIcon(0,WindowID(gmwind),ImageID(aico))
SysTrayIconToolTip(0,"Runt utility Left click to Show, Right click to End")

     

If Not AddToDB(@mod)
  HideWindow(gmwind,0)
EndIf 

loadquicklaunch()

Repeat 
      
      EV = WaitWindowEvent()
      EVG = EventGadget()
      EVT = EventType()
      EVW=EventWindow()
       
      If ev <> 0 
      If EVW=gmwind
        If EV = #PB_Event_Menu
           MEV = EventMenu()
           Select MEV 
             Case 101,102,103,104,105,106,107,108,109   
               tmev = (mev)-101
               *v.vec = glapps(tmev)\head
               While *v 
                 If *v\file 
                    If *v\file <> "*"
                    SetCurrentDirectory(GetPathPart(*v\file))
                    RunProgram(*v\file)
                    Delay(100)
                    SetForegroundWindow_(WindowID(gmwind))
                    EndIf 
                  EndIf 
                  *v = *v\next
               Wend    
             Case #dell 
               pos = GetGadgetState(#TR_LAPPS)
               tf = GetGadgetItemText(#TR_LAPPS,pos)
               If Len(tf) > 1
                 RemoveGadgetItem(#TR_LAPPS,pos)
                 ct=0
                 While a < pos-1 
                    a + gLApps(ct)\count 
                    ct+1  
                 Wend 
                 If a > pos 
                   a=ct-1
                   *v.vec = gLApps(a)\head 
                 Else 
                   a=ct
                   *v.vec = gLApps(a)\head
                 EndIf 
                 ct=0
                 While *v 
                   If *v\name = tf  
                     DelElementV(gLApps(a),ct+1)
                     Break 
                   EndIf 
                   ct+1
                  *v=*v\next
                 Wend
               EndIf  
                             
             Case #M_About 
               about(WindowID(gmwind))
             Case #M_ReScan 
               Open_ScanGui(2)
             Case #down 
               If gpt < CountGadgetItems(#LV_APPS)
                 gpt+1
               Else 
                 gpt = 0
               EndIf        
               SetGadgetState(#LV_APPS,gpt)
               tapp = GetGadgetItemText(#LV_APPS,gpt)
               res = mt\LookUp(tapp.s)
               *v.vec = gApps(res)\head 
               While *v 
                  ct+1 
                  *v = *v\next 
               Wend 
               SetInfo(res,ct)
               ct=0
               
             Case #up 
                If gpt > 0 
                  gpt-1
                Else 
                  gpt = CountGadgetItems(#LV_APPS)
                EndIf 
                SetGadgetState(#LV_APPS,gpt)
                tapp = GetGadgetItemText(#LV_APPS,gpt)
                res = mt\LookUp(tapp.s)
                *v.vec = gApps(res)\head 
                While *v
                  ct+1 
                  *v = *v\next 
                Wend 
                SetInfo(res,ct)
                ct=0
                 
             Case #return   
               pos = GetGadgetState(#LV_APPS)
                If pos >= 0 
                  tapp.s = GetGadgetItemText(#LV_APPS,pos)
                  res = mt\LookUp(tapp.s)
                  *v.vec = gApps(res)\head 
                  tapp = GetGadgetText(#T_APP) 
                  While *v 
                    If *v\file = tapp 
                      Debug "run " + *v\file  
                      SetCurrentDirectory(GetPathPart(*v\file))
                      RunProgram(*v\file) 
                      SetForegroundWindow_(WindowID(gmwind))
                      SetGadgetText(#s_app,"")
                      SetActiveGadget(#S_APP)
                      Break   
                    Else   
                      *v = *v\next 
                    EndIf   
                  Wend 
                  
                EndIf 
              Case #left,#right 
                pos = GetGadgetState(#LV_APPS)
                 
                If pos >= 0 
                  tapp.s = GetGadgetItemText(#LV_APPS,pos)
                  res = mt\LookUp(tapp.s)
                  If res = lres And *tv\next 
                    *tv = *tv\next
                  Else 
                    *tv = gApps(res)\head 
                  EndIf 
                  lres = res 
                  SetGadgetText(#T_APP,*tv\file)
                EndIf
              Case #escape
                HideWindow(gmwind,1)
              Case #quit 
                 RemoveSysTrayIcon(0)
                 gclose =1  
               Case #M_ShortCut
                 AddtoStartMenu()
               Case #M_SaveIcon 
                 SaveDesktopIconsPositions()
               Case #M_RestoreIcon 
                 RestoreDesktopIconsPositions()
              EndSelect 
        ElseIf ev = #PB_Event_GadgetDrop
          If EventGadget() =#TR_LAPPS
            If EventDropAction() = #PB_Drag_Move
              RemoveGadgetItem(#TR_LAPPS,gSource)
              pos = GetGadgetState(#TR_LAPPS)
              For a = 0 To 9
                If gLApps(a)\count 
                  *v.vec = gLApps(a)\head 
                  ct=0
                  While *v 
                    If *v\name = EventDropText() 
                      tf = *v\file
                      DelElementV(gLApps(a),ct+1)
                      Break 2
                    EndIf 
                    ct+1
                    *v=*v\next
                  Wend
                 EndIf  
               Next
               ct=-1
               ct1=0
               For a = 0 To pos 
                 If Len(GetGadgetItemText(#TR_LAPPS,a)) = 1
                   ct+1
                   ct1=0
                 EndIf   
                 ct1+1
               Next  
               AddGadgetItem(#TR_LAPPS,pos,EventDropText(),0,1)
               
               InsertElementv(gLApps(ct),ct1)
               glapps(ct)\v\file = tf 
               glapps(ct)\v\name = EventDropText()
           
            Else   
              pos = GetGadgetState(#TR_LAPPS)
              id.s = GetGadgetItemText(#TR_LAPPS,pos)
              count = CountGadgetItems(#TR_LAPPS)
              For a = 0 To count
                If GetGadgetItemText(#TR_LAPPS,pos) = Str(a)
                  badd=1
                     
                  Debug "a= " +Str(a) + " pos= " + Str(pos)
                  If a = 1
                    AddGadgetItem(#TR_LAPPS,1,EventDropText(),0,1)
                  Else 
                    AddGadgetItem(#TR_LAPPS,pos+1,EventDropText(),0,1)
                  EndIf   
                    Break   
                EndIf 
              Next
              If badd
                 badd=0
                 ttapp = tapp
                 res = mt\LookUp(tapp.s)
                 *v.vec = gApps(res)\head 
                 tapp = GetGadgetText(#T_APP) 
                 While *v 
                    If *v\file = tapp 
                       Debug "file" + *v\file  
                       AddElementv(gLApps(a-1))
                       glapps(a-1)\v\file = *v\file 
                       glapps(a-1)\v\name = ttapp 
                       Break  
                    Else   
                      *v = *v\next 
                    EndIf   
                  Wend
              EndIf    
            EndIf 
          EndIf    
        ElseIf EV = #PB_Event_Gadget 
          Select EVG 
              Case #LV_APPS,#BG1 
                  If evt = #PB_EventType_LeftDoubleClick Or EVG = #BG1
                      pos = GetGadgetState(#LV_APPS)
                      tapp.s = GetGadgetItemText(#LV_APPS,pos)
                      res = mt\LookUp(tapp.s)
                      *v.vec = gApps(res)\head 
                      tapp = GetGadgetText(#T_APP) 
                      While *v 
                        If *v\file = tapp 
                          Debug "run " + *v\file  
                          SetCurrentDirectory(GetPathPart(*v\file))
                          RunProgram(*v\file) 
                          SetForegroundWindow_(WindowID(gmwind))
                          SetGadgetText(#s_app,"")
                          SetActiveGadget(#S_APP)
                          Break   
                        Else   
                          *v = *v\next 
                        EndIf   
                      Wend 
                  ElseIf evt = #PB_EventType_LeftClick     
                      gpt = GetGadgetState(#LV_APPS)
                      tapp.s = GetGadgetItemText(#LV_APPS,gpt)
                      res = mt\LookUp(tapp.s)
                      *v.vec = gApps(res)\head 
                      While *v 
                        ct+1 
                        *v = *v\next 
                      Wend 
                      SetInfo(res,ct)
                      ct=0
                      
                  ElseIf evt =  #PB_EventType_DragStart    
                    dragtxt.s = GetGadgetItemText(EventGadget(), GetGadgetState(EventGadget()))
                    If evg = #LV_APPS
                       DragText(dragtxt, #PB_Drag_Copy)
                    EndIf 
                   EndIf 
                  
               Case #TR_LAPPS 
                  If evt = #PB_EventType_RightClick    
                    If gi < 10
                      AddGadgetItem(#TR_LAPPS, -1,Str(gi),0,0)
                      gi+1
                    EndIf 
                  ElseIf evt =  #PB_EventType_DragStart   
                     dragtxt.s = GetGadgetItemText(EventGadget(), GetGadgetState(EventGadget()))
                     gSource = GetGadgetState(#TR_LAPPS)
                     Debug "drag " + Str(gsource) + " " + DragTxt 
                     DragText(dragtxt, #PB_Drag_Move)   
                   EndIf 
                                  
                  
                Case #S_APP 
                  If evt = #PB_EventType_Change
                    tapp.s = GetGadgetText(#S_APP) 
                    ClearGadgetItems(#LV_APPS)
                    mt\Enum(tapp,@UpdateList())
                    gpt=0
                    SetGadgetState(#LV_APPS,gpt)
                    tapp.s = GetGadgetItemText(#LV_APPS,gpt)
                    res = mt\LookUp(tapp.s)
                    *v.vec = gApps(res)\head 
                    While *v 
                       ct+1 
                       *v = *v\next 
                    Wend 
                    SetInfo(res,ct)
                    ct=0 
                  EndIf 
                
            EndSelect        
          ElseIf Ev = #PB_Event_SysTray
                
             If Evt = #PB_EventType_RightClick  
                SystemParametersInfo_(#SPI_GETWORKAREA,0,@rc,0)
                GetCursorPos_(@pt)        
                DisplayPopupMenu(#menu,WindowID(gmwind),pt\x-30,rc\bottom-30)
                             
             ElseIf evt = #PB_EventType_LeftClick
               HideWindow(gmwind,0)
             EndIf   
          ElseIf ev = #WM_CLOSE 
             HideWindow(gmwind,1)   
          EndIf
        ElseIf evw = gWindAbout 
          If ev = #WM_CLOSE 
            CloseWindow(gWindAbout) 
            gwindabout = 0
          ElseIf Ev = #PB_Event_Gadget
            If evg = #Hyp_link 
              RunProgram("http://www.idlearts.com")  
            EndIf   
          EndIf
            
      EndIf 
     EndIf       
    Until gclose 
    
    SaveQuickLaunch()
    FreeLaunchList()
    FreeFileList()
    
DataSection
   Ico:
   IncludeBinary "icon00.ico"
EndDataSection     
    
    

; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 46
; FirstLine = 27
; Folding = -H5--
; EnableThread
; EnableXP
; UseIcon = icon00.ico
; Executable = ..\runt.exe
; IncludeVersionInfo
; VersionField0 = 1.0.3.2
; VersionField1 = 1.0.3.2
; VersionField2 = IdleArts
; VersionField3 = Runt
; VersionField4 = 1.32
; VersionField5 = 1.32
; VersionField6 = auto complete run box utility
; VersionField7 = runt.exe
; VersionField8 = runt.exe
; VersionField9 = 2010 Andrew Ferguson
; VersionField10 = IdleArts